#region License Information
/* HeuristicLab
 * Copyright (C) 2002-2014 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
 *
 * This file is part of HeuristicLab.
 *
 * HeuristicLab is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * HeuristicLab is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
 */
#endregion

using HeuristicLab.Core.Networks.Views;
using HeuristicLab.MainForm;
using System.Windows.Forms;

namespace HeuristicLab.Networks.Programmable.Views {
  [View("UserDefinedNetwork View")]
  [Content(typeof(UserDefinedNetwork), true)]
  [Content(typeof(IUserDefinedNetwork), false)]
  public partial class UserDefinedNetworkView : NetworkView {
    public new IUserDefinedNetwork Content {
      get { return (IUserDefinedNetwork)base.Content; }
      set { base.Content = value; }
    }

    public UserDefinedNetworkView() {
      InitializeComponent();
    }

    protected override void OnContentChanged() {
      base.OnContentChanged();
      nodeCollectionView.Content = Content == null ? null : Content.Nodes;
      portCollectionView.Content = Content == null ? null : Content.Ports;
      programmableItemView.Content = Content;
    }

    protected override void SetEnabledStateOfControls() {
      base.SetEnabledStateOfControls();
      initializeButton.Enabled = Content != null && !ReadOnly && !Locked;
    }

    private void initializeButton_Click(object sender, System.EventArgs e) {
      Content.Initialize();
    }
  }
}
